diff --git a/gdb/addrmap.c b/gdb/addrmap.c
index c8fee38..c942c7b 100644
--- a/gdb/addrmap.c
+++ b/gdb/addrmap.c
@@ -18,9 +18,6 @@
    along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
 
 #include "defs.h"
-
-#include <stdlib.h>
-
 #include "splay-tree.h"
 #include "gdb_obstack.h"
 #include "addrmap.h"
diff --git a/gdb/bcache.c b/gdb/bcache.c
index 99e9184..0c87e2d 100644
--- a/gdb/bcache.c
+++ b/gdb/bcache.c
@@ -26,7 +26,6 @@
 #include "gdb_assert.h"
 
 #include <stddef.h>
-#include <stdlib.h>
 
 /* The type used to hold a single bcache string.  The user data is
    stored in d.data.  Since it can be any type, it needs to have the
diff --git a/gdb/common/buffer.c b/gdb/common/buffer.c
index a50c890..c291b32 100644
--- a/gdb/common/buffer.c
+++ b/gdb/common/buffer.c
@@ -27,7 +27,6 @@
 #include "buffer.h"
 #include "inttypes.h"
 
-#include <stdlib.h>
 #include <string.h>
 #include <stdint.h>
 
diff --git a/gdb/common/common-defs.h b/gdb/common/common-defs.h
index 0fc7af5..ed95a36 100644
--- a/gdb/common/common-defs.h
+++ b/gdb/common/common-defs.h
@@ -28,5 +28,6 @@
 #endif
 
 #include <stdio.h>
+#include <stdlib.h>
 
 #endif /* COMMON_DEFS_H */
diff --git a/gdb/common/common-utils.c b/gdb/common/common-utils.c
index 41ef289..ab05c9f 100644
--- a/gdb/common/common-utils.c
+++ b/gdb/common/common-utils.c
@@ -26,8 +26,6 @@
 #include "gdb_assert.h"
 #include <string.h>
 
-#include <stdlib.h>
-
 /* The xmalloc() (libiberty.h) family of memory management routines.
 
    These are like the ISO-C malloc() family except that they implement
diff --git a/gdb/cp-name-parser.y b/gdb/cp-name-parser.y
index 6a9d13d..3199aff 100644
--- a/gdb/cp-name-parser.y
+++ b/gdb/cp-name-parser.y
@@ -31,7 +31,6 @@
 
 #include "defs.h"
 
-#include <stdlib.h>
 #include <unistd.h>
 #include <string.h>
 
diff --git a/gdb/defs.h b/gdb/defs.h
index 49e45b8..2e1e06b 100644
--- a/gdb/defs.h
+++ b/gdb/defs.h
@@ -597,9 +597,6 @@ enum gdb_osabi
 
 /* From other system libraries */
 
-#include <stdlib.h>
-
-
 #ifndef atof
 extern double atof (const char *);	/* X3.159-1989  4.10.1.1 */
 #endif
diff --git a/gdb/gdbserver/inferiors.c b/gdb/gdbserver/inferiors.c
index 48d7700..608a997 100644
--- a/gdb/gdbserver/inferiors.c
+++ b/gdb/gdbserver/inferiors.c
@@ -19,7 +19,6 @@
    along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
 
 #include "server.h"
-#include <stdlib.h>
 #include "gdbthread.h"
 #include "dll.h"
 
diff --git a/gdb/gdbserver/linux-low.c b/gdb/gdbserver/linux-low.c
index 0b9353e..b599bef 100644
--- a/gdb/gdbserver/linux-low.c
+++ b/gdb/gdbserver/linux-low.c
@@ -31,7 +31,6 @@
 #include <sys/ioctl.h>
 #include <fcntl.h>
 #include <string.h>
-#include <stdlib.h>
 #include <unistd.h>
 #include <errno.h>
 #include <sys/syscall.h>
diff --git a/gdb/gdbserver/regcache.c b/gdb/gdbserver/regcache.c
index bed10b4..5c973b1 100644
--- a/gdb/gdbserver/regcache.c
+++ b/gdb/gdbserver/regcache.c
@@ -21,8 +21,6 @@
 #include "gdbthread.h"
 #include "tdesc.h"
 #include "rsp-low.h"
-
-#include <stdlib.h>
 #include <string.h>
 
 #ifndef IN_PROCESS_AGENT
diff --git a/gdb/gdbserver/server.h b/gdb/gdbserver/server.h
index 743a368..a15ba36 100644
--- a/gdb/gdbserver/server.h
+++ b/gdb/gdbserver/server.h
@@ -30,7 +30,6 @@
 #include "version.h"
 
 #include <stdarg.h>
-#include <stdlib.h>
 #ifdef HAVE_ERRNO_H
 #include <errno.h>
 #endif
diff --git a/gdb/gdbserver/spu-low.c b/gdb/gdbserver/spu-low.c
index 67ff147..ba2780b 100644
--- a/gdb/gdbserver/spu-low.c
+++ b/gdb/gdbserver/spu-low.c
@@ -24,7 +24,6 @@
 #include <sys/ptrace.h>
 #include <fcntl.h>
 #include <string.h>
-#include <stdlib.h>
 #include <unistd.h>
 #include <errno.h>
 #include <sys/syscall.h>
diff --git a/gdb/gdbserver/tracepoint.c b/gdb/gdbserver/tracepoint.c
index 7c4b291..31be953 100644
--- a/gdb/gdbserver/tracepoint.c
+++ b/gdb/gdbserver/tracepoint.c
@@ -7110,7 +7110,6 @@ gdb_ust_init (void)
 #endif /* HAVE_UST */
 
 #include <sys/syscall.h>
-#include <stdlib.h>
 
 static void
 gdb_agent_remove_socket (void)
diff --git a/gdb/gdbserver/utils.c b/gdb/gdbserver/utils.c
index b87bcc9..a0febb1 100644
--- a/gdb/gdbserver/utils.c
+++ b/gdb/gdbserver/utils.c
@@ -18,7 +18,6 @@
 
 #include "server.h"
 #include <string.h>
-#include <stdlib.h>
 #if HAVE_ERRNO_H
 #include <errno.h>
 #endif
diff --git a/gdb/go32-nat.c b/gdb/go32-nat.c
index 42133d6..a8c54fa 100644
--- a/gdb/go32-nat.c
+++ b/gdb/go32-nat.c
@@ -105,7 +105,6 @@
 #include "cli/cli-utils.h"
 #include "inf-child.h"
 
-#include <stdlib.h>
 #include <ctype.h>
 #include <errno.h>
 #include <unistd.h>
diff --git a/gdb/mn10300-linux-tdep.c b/gdb/mn10300-linux-tdep.c
index 4377463..1b72efa 100644
--- a/gdb/mn10300-linux-tdep.c
+++ b/gdb/mn10300-linux-tdep.c
@@ -33,8 +33,6 @@
 #include "tramp-frame.h"
 #include "linux-tdep.h"
 
-#include <stdlib.h>
-
 /* Transliterated from <asm-mn10300/elf.h>...  */
 #define MN10300_ELF_NGREG 28
 #define MN10300_ELF_NFPREG 32
diff --git a/gdb/nat/linux-osdata.c b/gdb/nat/linux-osdata.c
index dae637b..d9d1325 100644
--- a/gdb/nat/linux-osdata.c
+++ b/gdb/nat/linux-osdata.c
@@ -28,7 +28,6 @@
 #include <sys/types.h>
 #include <sys/sysinfo.h>
 #include <ctype.h>
-#include <stdlib.h>
 #include <string.h>
 #include <utmp.h>
 #include <time.h>
diff --git a/gdb/tui/tui.c b/gdb/tui/tui.c
index 413ec20..7add8ba 100644
--- a/gdb/tui/tui.c
+++ b/gdb/tui/tui.c
@@ -38,7 +38,6 @@
 #include "symtab.h"
 #include "source.h"
 
-#include <stdlib.h>
 #include <ctype.h>
 #include <signal.h>
 #include <fcntl.h>
diff --git a/gdb/windows-nat.c b/gdb/windows-nat.c
index 3d101a1..5dcd520 100644
--- a/gdb/windows-nat.c
+++ b/gdb/windows-nat.c
@@ -35,7 +35,6 @@
 #include <signal.h>
 #include <sys/types.h>
 #include <fcntl.h>
-#include <stdlib.h>
 #include <windows.h>
 #include <imagehlp.h>
 #include <psapi.h>