diff --git a/gdb/amd64fbsd-nat.c b/gdb/amd64fbsd-nat.c
index 72dc39b..3650bb5 100644
--- a/gdb/amd64fbsd-nat.c
+++ b/gdb/amd64fbsd-nat.c
@@ -24,7 +24,6 @@
 
 #include "gdb_assert.h"
 #include <signal.h>
-#include <stddef.h>
 #include <sys/types.h>
 #include <sys/ptrace.h>
 #include <sys/sysctl.h>
diff --git a/gdb/bcache.c b/gdb/bcache.c
index 0c87e2d..44530bc 100644
--- a/gdb/bcache.c
+++ b/gdb/bcache.c
@@ -25,8 +25,6 @@
 #include <string.h>		/* For memcpy declaration */
 #include "gdb_assert.h"
 
-#include <stddef.h>
-
 /* The type used to hold a single bcache string.  The user data is
    stored in d.data.  Since it can be any type, it needs to have the
    same alignment as the most strict alignment of any type on the host
diff --git a/gdb/charset.c b/gdb/charset.c
index 6f413a2..3e7a85c 100644
--- a/gdb/charset.c
+++ b/gdb/charset.c
@@ -29,7 +29,6 @@
 #include "arch-utils.h"
 #include "gdb_vecs.h"
 
-#include <stddef.h>
 #include <string.h>
 #include <ctype.h>
 
diff --git a/gdb/common/buffer.h b/gdb/common/buffer.h
index c6abc8b..d051bfb 100644
--- a/gdb/common/buffer.h
+++ b/gdb/common/buffer.h
@@ -20,7 +20,6 @@
 #ifndef BUFFER_H
 #define BUFFER_H
 
-#include <stddef.h>
 #include <string.h>
 #include "ansidecl.h"
 
diff --git a/gdb/common/common-defs.h b/gdb/common/common-defs.h
index d227b00..f1fd363 100644
--- a/gdb/common/common-defs.h
+++ b/gdb/common/common-defs.h
@@ -30,5 +30,6 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <stdarg.h>
+#include <stddef.h>
 
 #endif /* COMMON_DEFS_H */
diff --git a/gdb/common/common-utils.h b/gdb/common/common-utils.h
index dff7b53..4dc4329 100644
--- a/gdb/common/common-utils.h
+++ b/gdb/common/common-utils.h
@@ -21,7 +21,6 @@
 #define COMMON_UTILS_H
 
 #include "ansidecl.h"
-#include <stddef.h>
 
 /* If possible, define FUNCTION_NAME, a macro containing the name of
    the function being defined.  Since this macro may not always be
diff --git a/gdb/common/vec.h b/gdb/common/vec.h
index 7bae2ff..2a39eff 100644
--- a/gdb/common/vec.h
+++ b/gdb/common/vec.h
@@ -20,8 +20,6 @@
 #if !defined (GDB_VEC_H)
 #define GDB_VEC_H
 
-#include <stddef.h>
-
 #include <string.h>
 #include "gdb_assert.h"
 
diff --git a/gdb/defs.h b/gdb/defs.h
index 00cb8e7..58098a9 100644
--- a/gdb/defs.h
+++ b/gdb/defs.h
@@ -46,8 +46,6 @@
    included, so it's ok to blank out gstdint.h.  */
 #define GCC_GENERATED_STDINT_H 1
 
-#include <stddef.h>
-
 #include <unistd.h>
 
 /* For gnulib's PATH_MAX.  */
diff --git a/gdb/gdbserver/linux-x86-low.c b/gdb/gdbserver/linux-x86-low.c
index 850ed7c..7a8a473 100644
--- a/gdb/gdbserver/linux-x86-low.c
+++ b/gdb/gdbserver/linux-x86-low.c
@@ -18,7 +18,6 @@
    along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
 
 #include "server.h"
-#include <stddef.h>
 #include <signal.h>
 #include <limits.h>
 #include <inttypes.h>
diff --git a/gdb/gdbserver/lynx-ppc-low.c b/gdb/gdbserver/lynx-ppc-low.c
index d6ead6f..7884f23 100644
--- a/gdb/gdbserver/lynx-ppc-low.c
+++ b/gdb/gdbserver/lynx-ppc-low.c
@@ -19,7 +19,6 @@
 #include "lynx-low.h"
 
 #include <stdint.h>
-#include <stddef.h>
 #include <limits.h>
 #include <sys/ptrace.h>
 
diff --git a/gdb/gdbserver/tracepoint.c b/gdb/gdbserver/tracepoint.c
index 31be953..302b9c7 100644
--- a/gdb/gdbserver/tracepoint.c
+++ b/gdb/gdbserver/tracepoint.c
@@ -26,7 +26,6 @@
 #include <fcntl.h>
 #include <unistd.h>
 #include <sys/time.h>
-#include <stddef.h>
 #include <inttypes.h>
 #include <stdint.h>
 
diff --git a/gdb/i386bsd-nat.c b/gdb/i386bsd-nat.c
index acae6cb..4bee159 100644
--- a/gdb/i386bsd-nat.c
+++ b/gdb/i386bsd-nat.c
@@ -23,7 +23,6 @@
 
 #include "gdb_assert.h"
 #include <signal.h>
-#include <stddef.h>
 #include <sys/types.h>
 #include <sys/ptrace.h>
 #include <machine/reg.h>
diff --git a/gdb/nat/linux-btrace.h b/gdb/nat/linux-btrace.h
index a96d9d1..5faf535 100644
--- a/gdb/nat/linux-btrace.h
+++ b/gdb/nat/linux-btrace.h
@@ -25,7 +25,6 @@
 #include "btrace-common.h"
 #include "vec.h"
 #include "ptid.h"
-#include <stddef.h>
 #include <stdint.h>
 
 #if HAVE_LINUX_PERF_EVENT_H
diff --git a/gdb/ppcfbsd-nat.c b/gdb/ppcfbsd-nat.c
index 079bd12..aeb47af 100644
--- a/gdb/ppcfbsd-nat.c
+++ b/gdb/ppcfbsd-nat.c
@@ -23,7 +23,6 @@
 #include "regcache.h"
 
 #include "gdb_assert.h"
-#include <stddef.h>
 #include <sys/types.h>
 #include <sys/procfs.h>
 #include <sys/ptrace.h>
diff --git a/gdb/ppcnbsd-tdep.h b/gdb/ppcnbsd-tdep.h
index 747b452..6631fc1 100644
--- a/gdb/ppcnbsd-tdep.h
+++ b/gdb/ppcnbsd-tdep.h
@@ -20,8 +20,6 @@
 #ifndef PPCNBSD_TDEP_H
 #define PPCNBSD_TDEP_H
 
-#include <stddef.h>
-
 struct regset;
 
 /* Register offsets for NetBSD/powerpc.  */
diff --git a/gdb/ppcobsd-nat.c b/gdb/ppcobsd-nat.c
index 1aa56d0..9e3e85b 100644
--- a/gdb/ppcobsd-nat.c
+++ b/gdb/ppcobsd-nat.c
@@ -23,7 +23,6 @@
 #include "regcache.h"
 
 #include "gdb_assert.h"
-#include <stddef.h>
 #include <sys/types.h>
 #include <sys/ptrace.h>
 #include <sys/signal.h>
diff --git a/gdb/ppcobsd-tdep.h b/gdb/ppcobsd-tdep.h
index 8c9ac3a..7d8d13e 100644
--- a/gdb/ppcobsd-tdep.h
+++ b/gdb/ppcobsd-tdep.h
@@ -20,8 +20,6 @@
 #ifndef PPCOBSD_TDEP_H
 #define PPCOBSD_TDEP_H
 
-#include <stddef.h>
-
 struct regset;
 struct regcache;
 
diff --git a/gdb/python/py-gdb-readline.c b/gdb/python/py-gdb-readline.c
index e926f8e..b778aa9 100644
--- a/gdb/python/py-gdb-readline.c
+++ b/gdb/python/py-gdb-readline.c
@@ -24,8 +24,6 @@
 #include "cli/cli-utils.h"
 #include <string.h>
 
-#include <stddef.h>
-
 /* Readline function suitable for PyOS_ReadlineFunctionPointer, which
    is used for Python's interactive parser and raw_input.  In both
    cases, sys_stdin and sys_stdout are always stdin and stdout